#pragma once
#include "pinConfig.hpp"
#include "FreeRTOS.h"
#include "task.h"
#include "semphr.h"

void vInterruptionTaskFn(void *pvParameters);
void vButtonTaskFn(void *pvParameters);

class VacumControl {
private:
    bool state = false;
    xSemaphoreHandle vacumMutex;
    xSemaphoreHandle interruptionSemaphore;

    xTaskHandle interruptionTask;
    xTaskHandle buttonTask;
public:
    VacumControl();

    void initVacumPins();
    void setState(bool on);

    void interruptionTaskFn();
    void buttonTaskFn();

};

